config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.radiusd.new
config etc/raddb/clients.conf.new
config etc/raddb/eap.conf.new
config etc/raddb/experimental.conf.new
config etc/raddb/policy.conf.new
config etc/raddb/proxy.conf.new
config etc/raddb/radiusd.conf.new
config etc/raddb/sql.conf.new
config etc/raddb/sqlippool.conf.new
config etc/raddb/templates.conf.new
config etc/raddb/users.new

( cd etc/raddb/sites-enabled ; rm -rf default )
( cd etc/raddb/sites-enabled ; ln -sf ../sites-available/default default )
( cd etc/raddb/sites-enabled ; rm -rf inner-tunnel )
( cd etc/raddb/sites-enabled ; ln -sf ../sites-available/inner-tunnel inner-tunnel )
( cd etc/raddb/sites-enabled ; rm -rf control-socket )
( cd etc/raddb/sites-enabled ; ln -sf ../sites-available/control-socket control-socket )
( cd usr/lib64 ; rm -rf rlm_detail-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_detail.la rlm_detail-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_realm-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_realm.la rlm_realm-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_eap_tls-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_eap_tls.la rlm_eap_tls-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_eap_md5-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_eap_md5.la rlm_eap_md5-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_checkval-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_checkval.la rlm_checkval-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_sqlcounter.so )
( cd usr/lib64 ; ln -sf rlm_sqlcounter-2.2.9.so rlm_sqlcounter.so )
( cd usr/lib64 ; rm -rf rlm_sqlippool-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_sqlippool.la rlm_sqlippool-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_attr_rewrite.so )
( cd usr/lib64 ; ln -sf rlm_attr_rewrite-2.2.9.so rlm_attr_rewrite.so )
( cd usr/lib64 ; rm -rf rlm_expr-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_expr.la rlm_expr-2.2.9.la )
( cd usr/lib64 ; rm -rf libfreeradius-eap.so )
( cd usr/lib64 ; ln -sf libfreeradius-eap-2.2.9.so libfreeradius-eap.so )
( cd usr/lib64 ; rm -rf rlm_fastusers.so )
( cd usr/lib64 ; ln -sf rlm_fastusers-2.2.9.so rlm_fastusers.so )
( cd usr/lib64 ; rm -rf rlm_mschap.so )
( cd usr/lib64 ; ln -sf rlm_mschap-2.2.9.so rlm_mschap.so )
( cd usr/lib64 ; rm -rf rlm_files-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_files.la rlm_files-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_eap.so )
( cd usr/lib64 ; ln -sf rlm_eap-2.2.9.so rlm_eap.so )
( cd usr/lib64 ; rm -rf rlm_otp-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_otp.la rlm_otp-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_perl.so )
( cd usr/lib64 ; ln -sf rlm_perl-2.2.9.so rlm_perl.so )
( cd usr/lib64 ; rm -rf rlm_mschap-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_mschap.la rlm_mschap-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_chap.so )
( cd usr/lib64 ; ln -sf rlm_chap-2.2.9.so rlm_chap.so )
( cd usr/lib64 ; rm -rf libfreeradius-radius.so )
( cd usr/lib64 ; ln -sf libfreeradius-radius-020209.so libfreeradius-radius.so )
( cd usr/lib64 ; rm -rf rlm_exec-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_exec.la rlm_exec-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_sqlippool.so )
( cd usr/lib64 ; ln -sf rlm_sqlippool-2.2.9.so rlm_sqlippool.so )
( cd usr/lib64 ; rm -rf rlm_eap-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_eap.la rlm_eap-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_dynamic_clients-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_dynamic_clients.la rlm_dynamic_clients-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_fastusers-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_fastusers.la rlm_fastusers-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_always.so )
( cd usr/lib64 ; ln -sf rlm_always-2.2.9.so rlm_always.so )
( cd usr/lib64 ; rm -rf rlm_cache.so )
( cd usr/lib64 ; ln -sf rlm_cache-2.2.9.so rlm_cache.so )
( cd usr/lib64 ; rm -rf rlm_sql_mysql-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_sql_mysql.la rlm_sql_mysql-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_soh-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_soh.la rlm_soh-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_passwd.so )
( cd usr/lib64 ; ln -sf rlm_passwd-2.2.9.so rlm_passwd.so )
( cd usr/lib64 ; rm -rf rlm_ldap.so )
( cd usr/lib64 ; ln -sf rlm_ldap-2.2.9.so rlm_ldap.so )
( cd usr/lib64 ; rm -rf rlm_digest-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_digest.la rlm_digest-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_wimax.so )
( cd usr/lib64 ; ln -sf rlm_wimax-2.2.9.so rlm_wimax.so )
( cd usr/lib64 ; rm -rf rlm_passwd-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_passwd.la rlm_passwd-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_unix-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_unix.la rlm_unix-2.2.9.la )
( cd usr/lib64 ; rm -rf libfreeradius-eap-2.2.9.la )
( cd usr/lib64 ; ln -sf libfreeradius-eap.la libfreeradius-eap-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_ippool.so )
( cd usr/lib64 ; ln -sf rlm_ippool-2.2.9.so rlm_ippool.so )
( cd usr/lib64 ; rm -rf rlm_otp.so )
( cd usr/lib64 ; ln -sf rlm_otp-2.2.9.so rlm_otp.so )
( cd usr/lib64 ; rm -rf rlm_expr.so )
( cd usr/lib64 ; ln -sf rlm_expr-2.2.9.so rlm_expr.so )
( cd usr/lib64 ; rm -rf rlm_sql-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_sql.la rlm_sql-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_sql_mysql.so )
( cd usr/lib64 ; ln -sf rlm_sql_mysql-2.2.9.so rlm_sql_mysql.so )
( cd usr/lib64 ; rm -rf rlm_replicate-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_replicate.la rlm_replicate-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_pap-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_pap.la rlm_pap-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_digest.so )
( cd usr/lib64 ; ln -sf rlm_digest-2.2.9.so rlm_digest.so )
( cd usr/lib64 ; rm -rf rlm_eap_peap-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_eap_peap.la rlm_eap_peap-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_eap_md5.so )
( cd usr/lib64 ; ln -sf rlm_eap_md5-2.2.9.so rlm_eap_md5.so )
( cd usr/lib64 ; rm -rf rlm_eap_peap.so )
( cd usr/lib64 ; ln -sf rlm_eap_peap-2.2.9.so rlm_eap_peap.so )
( cd usr/lib64 ; rm -rf rlm_sql_log.so )
( cd usr/lib64 ; ln -sf rlm_sql_log-2.2.9.so rlm_sql_log.so )
( cd usr/lib64 ; rm -rf libfreeradius-radius-020209.la )
( cd usr/lib64 ; ln -sf libfreeradius-radius.la libfreeradius-radius-020209.la )
( cd usr/lib64 ; rm -rf rlm_ippool-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_ippool.la rlm_ippool-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_eap_mschapv2.so )
( cd usr/lib64 ; ln -sf rlm_eap_mschapv2-2.2.9.so rlm_eap_mschapv2.so )
( cd usr/lib64 ; rm -rf rlm_eap_sim.so )
( cd usr/lib64 ; ln -sf rlm_eap_sim-2.2.9.so rlm_eap_sim.so )
( cd usr/lib64 ; rm -rf rlm_eap_gtc.so )
( cd usr/lib64 ; ln -sf rlm_eap_gtc-2.2.9.so rlm_eap_gtc.so )
( cd usr/lib64 ; rm -rf rlm_chap-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_chap.la rlm_chap-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_preprocess-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_preprocess.la rlm_preprocess-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_acctlog.so )
( cd usr/lib64 ; ln -sf rlm_acctlog-2.2.9.so rlm_acctlog.so )
( cd usr/lib64 ; rm -rf rlm_acctlog-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_acctlog.la rlm_acctlog-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_dynamic_clients.so )
( cd usr/lib64 ; ln -sf rlm_dynamic_clients-2.2.9.so rlm_dynamic_clients.so )
( cd usr/lib64 ; rm -rf rlm_detail.so )
( cd usr/lib64 ; ln -sf rlm_detail-2.2.9.so rlm_detail.so )
( cd usr/lib64 ; rm -rf rlm_python-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_python.la rlm_python-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_linelog-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_linelog.la rlm_linelog-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_sql_iodbc.so )
( cd usr/lib64 ; ln -sf rlm_sql_iodbc-2.2.9.so rlm_sql_iodbc.so )
( cd usr/lib64 ; rm -rf rlm_wimax-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_wimax.la rlm_wimax-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_radutmp.so )
( cd usr/lib64 ; ln -sf rlm_radutmp-2.2.9.so rlm_radutmp.so )
( cd usr/lib64 ; rm -rf rlm_sqlcounter-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_sqlcounter.la rlm_sqlcounter-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_python.so )
( cd usr/lib64 ; ln -sf rlm_python-2.2.9.so rlm_python.so )
( cd usr/lib64 ; rm -rf rlm_sql_iodbc-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_sql_iodbc.la rlm_sql_iodbc-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_eap_tls.so )
( cd usr/lib64 ; ln -sf rlm_eap_tls-2.2.9.so rlm_eap_tls.so )
( cd usr/lib64 ; rm -rf rlm_files.so )
( cd usr/lib64 ; ln -sf rlm_files-2.2.9.so rlm_files.so )
( cd usr/lib64 ; rm -rf rlm_counter-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_counter.la rlm_counter-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_sql_log-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_sql_log.la rlm_sql_log-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_policy-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_policy.la rlm_policy-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_eap_leap.so )
( cd usr/lib64 ; ln -sf rlm_eap_leap-2.2.9.so rlm_eap_leap.so )
( cd usr/lib64 ; rm -rf rlm_attr_filter-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_attr_filter.la rlm_attr_filter-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_eap_ttls-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_eap_ttls.la rlm_eap_ttls-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_sql.so )
( cd usr/lib64 ; ln -sf rlm_sql-2.2.9.so rlm_sql.so )
( cd usr/lib64 ; rm -rf rlm_eap_leap-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_eap_leap.la rlm_eap_leap-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_policy.so )
( cd usr/lib64 ; ln -sf rlm_policy-2.2.9.so rlm_policy.so )
( cd usr/lib64 ; rm -rf rlm_radutmp-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_radutmp.la rlm_radutmp-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_realm.so )
( cd usr/lib64 ; ln -sf rlm_realm-2.2.9.so rlm_realm.so )
( cd usr/lib64 ; rm -rf rlm_preprocess.so )
( cd usr/lib64 ; ln -sf rlm_preprocess-2.2.9.so rlm_preprocess.so )
( cd usr/lib64 ; rm -rf rlm_eap_gtc-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_eap_gtc.la rlm_eap_gtc-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_attr_filter.so )
( cd usr/lib64 ; ln -sf rlm_attr_filter-2.2.9.so rlm_attr_filter.so )
( cd usr/lib64 ; rm -rf rlm_always-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_always.la rlm_always-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_checkval.so )
( cd usr/lib64 ; ln -sf rlm_checkval-2.2.9.so rlm_checkval.so )
( cd usr/lib64 ; rm -rf rlm_pap.so )
( cd usr/lib64 ; ln -sf rlm_pap-2.2.9.so rlm_pap.so )
( cd usr/lib64 ; rm -rf rlm_copy_packet-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_copy_packet.la rlm_copy_packet-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_expiration-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_expiration.la rlm_expiration-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_acct_unique.so )
( cd usr/lib64 ; ln -sf rlm_acct_unique-2.2.9.so rlm_acct_unique.so )
( cd usr/lib64 ; rm -rf rlm_copy_packet.so )
( cd usr/lib64 ; ln -sf rlm_copy_packet-2.2.9.so rlm_copy_packet.so )
( cd usr/lib64 ; rm -rf rlm_logintime-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_logintime.la rlm_logintime-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_perl-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_perl.la rlm_perl-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_replicate.so )
( cd usr/lib64 ; ln -sf rlm_replicate-2.2.9.so rlm_replicate.so )
( cd usr/lib64 ; rm -rf rlm_ldap-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_ldap.la rlm_ldap-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_cache-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_cache.la rlm_cache-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_attr_rewrite-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_attr_rewrite.la rlm_attr_rewrite-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_eap_sim-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_eap_sim.la rlm_eap_sim-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_unix.so )
( cd usr/lib64 ; ln -sf rlm_unix-2.2.9.so rlm_unix.so )
( cd usr/lib64 ; rm -rf rlm_exec.so )
( cd usr/lib64 ; ln -sf rlm_exec-2.2.9.so rlm_exec.so )
( cd usr/lib64 ; rm -rf rlm_logintime.so )
( cd usr/lib64 ; ln -sf rlm_logintime-2.2.9.so rlm_logintime.so )
( cd usr/lib64 ; rm -rf rlm_soh.so )
( cd usr/lib64 ; ln -sf rlm_soh-2.2.9.so rlm_soh.so )
( cd usr/lib64 ; rm -rf rlm_acct_unique-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_acct_unique.la rlm_acct_unique-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_eap_mschapv2-2.2.9.la )
( cd usr/lib64 ; ln -sf rlm_eap_mschapv2.la rlm_eap_mschapv2-2.2.9.la )
( cd usr/lib64 ; rm -rf rlm_linelog.so )
( cd usr/lib64 ; ln -sf rlm_linelog-2.2.9.so rlm_linelog.so )
( cd usr/lib64 ; rm -rf rlm_counter.so )
( cd usr/lib64 ; ln -sf rlm_counter-2.2.9.so rlm_counter.so )
( cd usr/lib64 ; rm -rf rlm_expiration.so )
( cd usr/lib64 ; ln -sf rlm_expiration-2.2.9.so rlm_expiration.so )
( cd usr/lib64 ; rm -rf rlm_eap_ttls.so )
( cd usr/lib64 ; ln -sf rlm_eap_ttls-2.2.9.so rlm_eap_ttls.so )
